/***************************************************************************
Copyright (c) 2016, Guillaume Baud-Berthier, SafeRiver/LaBRI

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
IN THE SOFTWARE.
***************************************************************************/

#include "utils.h"

int new_var() {
  return (vars = vars+2);
}

/* ========================================================================== */
/*                      List prop_tr_un_fl function                           */
/* ========================================================================== */
int compare_ptuf(prop_tr_un_fl *ptuf1, prop_tr_un_fl *ptuf2) {
  if (ptuf1->op == ptuf2->op) {
    if (ptuf1->op == VAR) {
      return ptuf1->lit < ptuf2->lit;
	
    } else {
      return ptuf1->lp->size < ptuf2->lp->size;
    }
    
  } else {
    if (ptuf1->op == VAR)
      return 1;
    if (ptuf2->op == VAR)
      return 0;
    if (ptuf1->op == AND)
      return 1;
    if (ptuf2->op == AND)
      return 0;
  }
  return 0;
}

void insert_ordered(list_ptuf *lp, prop_tr_un_fl *ptuf) {
  if (!lp->size) {
    list_ptuf_e *lpe = new list_ptuf_e();
    lpe->ptuf = ptuf;
    lp->size = 1;
    lp->head = lpe;
    lp->tail = lpe;

  } else {
    bool inserted = 0;
    list_ptuf_e *e = lp->head;
    while(!inserted) {
      if (compare_ptuf(ptuf, e->ptuf)) { 
	list_ptuf_e *lpe = new list_ptuf_e();
	lpe->ptuf = ptuf;
	lpe->prev = e->prev;
	lpe->next = e;
	if (lpe->prev == NULL)
	  lp->head = lpe;
	else
	  e->prev->next = lpe;
	e->prev = lpe;
	lp->size++;
	inserted = 1;
      } else {
	if (e->next == NULL) {
	  list_ptuf_e *lpe = new list_ptuf_e();
	  lpe->ptuf = ptuf;
	  lpe->prev = lp->tail;
	  lp->tail->next = lpe;
	  lp->tail = lpe;
	  lp->size++;
	  inserted = 1;
	}
	e = e->next;
      }
    }
  }
}

void destroy_ptuf(prop_tr_un_fl *ptuf) {
  if (ptuf->lp != NULL) {
    list_ptuf_e *it = ptuf->lp->head;
    list_ptuf_e *it_prev;
    
    while(it != NULL) {
      destroy_ptuf(it->ptuf);
      it_prev = it;
      it = it->next;
      delete it_prev;
    }
    delete ptuf->lp;
  }
  delete ptuf;
}
